<!-- commentList 评价列表-->
<template>
  <div>
    <div class="mb20">
      <div>
        <el-input clearable class="w250 mr20" v-model="search_data.search" placeholder="搜索订单号"></el-input>

        <el-select clearable class="mr20" v-model="search_data.status" placeholder="请选择状态">
          <el-option label="请选择状态" value=""></el-option>
          <el-option v-for="item in  GetBaseData('order_comment','status')" :key="item.id" :label="item.name" :value="item.id"></el-option>

        </el-select>
        <el-button size="small" icon="el-icon-search" @click.native="m_search" type="primary">搜索</el-button>

      </div>
      <div class="mt20">
        <el-button size="small" icon="el-icon-circle-check" @click.native='m_examine(1)' type="primary">审核通过</el-button>
        <el-button size="small" icon="el-icon-circle-close" @click.native='m_examine(2)' type="danger">审核失败</el-button>
      </div>
    </div>

    <div>
      <el-table ref="m_table" size="mini" border @selection-change="m_handleSelectionChange" @current-change="m_handleCurrentChange" class="mtable" :stripe="true" tooltip-effect="dark" :highlight-current-row='true' :data="m_list" style="width: 100%">
        <el-table-column align="center" type="selection" width="55"></el-table-column>


        <el-table-column align="center" prop="order_no" label="订单号"  width="170"> </el-table-column>
                <el-table-column align="center" prop="nickname" label="会员"  width="120"> </el-table-column>
        <el-table-column align="center" label="评价图片">
          <template slot-scope="scope">
            <div v-if="scope.row.imgArr.length">
              <viewer :images="scope.row.imgArr">
                <img class="imgClass" v-for="(src , index) in scope.row.imgArr" :src="src" :key="index" width="300">
              </viewer>
            </div>
          </template>
        </el-table-column>
        <el-table-column align="center" label="星级" width="160" >
          <template slot-scope="scope">
            <el-rate v-model="scope.row.score*1" disabled >
            </el-rate>
          </template>
        </el-table-column>

        <el-table-column align="center" prop="content" label="内容"> </el-table-column>

        <el-table-column align="center" width="100" prop="status" label="状态">
          <template slot-scope="scope"><span :class="scope.row.status|statusClass">{{scope.row.status | BaseData('order_comment','status')}}</span></template>
        </el-table-column>

        <el-table-column align="center" prop="created_at" label="创建时间"> </el-table-column>

        <el-table-column align="center" label="操作" width="120">
          <template slot-scope="scope">
            <el-button size="mini"  @click.native='give_reply(scope.row)' type="danger">回复留言</el-button>
            <el-button size="mini"  @click.native='apply_failed(scope.row)' type="danger">审核失败</el-button>
          </template>
        </el-table-column>
      </el-table>
      <Paging class="mt20 mb30" :pageIndex="m_page.page" :pageSize="m_page.limit" :pageTotal="m_page.total" @changeSize="m_changesize" @changeIndex="m_changeindex"></Paging>

    </div>

    <!-- 审核失败 -->
    <el-dialog width="400px" title="审核失败" v-if="dialogFormVisible" :visible.sync="dialogFormVisible">
      <el-form :model="formData" ref="ruleForm" :rules="m_rules">
        <!--失敗原因  -->
        <el-form-item label="失败原因" prop="remark">
          <el-input type="textarea" v-model="formData.remark"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <!-- 取 消 -->
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <!-- 确 定 -->
        <el-button type="primary" :loading="m_loading" @click="submit">确 定</el-button>
      </div>
    </el-dialog>

    <!-- 审核失败 -->
    <el-dialog width="400px" title="回复客户" v-if="dialogReplyVisible" :visible.sync="dialogReplyVisible">
      <el-form :model="formReply" ref="ruleForm">
        <el-form-item label="图片" prop="img">
          <el-upload 
            class="avatar-uploader" 
            :action="m_action" 
            :show-file-list="true" 
            name="images"
            :on-remove="handleAvatarRemove"
            :before-remove="beforeAvatarRemove"
            :limit="6"
            :on-exceed="handleAvatarExceed"
            :with-credentials="true" 
            :on-success="handleAvatarSuccess"
            multiple
            :file-list="fileList"
          >
            <img v-if="formReply.img" :src="formReply.img" class="avatar">
            <i v-else class="el-icon-plus avatar-uploader-icon"></i>
          </el-upload>
          <p class="m_red">( 最多6张图 )</p>
        </el-form-item>
        <!--失敗原因  -->
        <el-form-item label="内容" prop="reply">
          <el-input type="textarea" v-model="formReply.content"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <!-- 取 消 -->
        <el-button @click="dialogReplyVisible = false">取 消</el-button>
        <!-- 确 定 -->
        <el-button type="primary" :loading="m_loading" @click="submitReply">回复</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
export default {
  name: 'commentList',
  data() {
    return {
      dialogFormVisible: false,
      dialogReplyVisible: false,
      search_data: {
        search: "",
        status: ""
      },

      formData: {
        id: [],
        status: 2,
        remark: ''
      },
      formReply: {
        id: [],
        content: '',
        img: [],
        rawImg: [],
        button: false,
        preview: false,
      },
      fileList: [],
    }
  },
  mounted() {
    this.init()
  },
  methods: {
    init() {

      this.getDatalist()
    },
    getDatalist() {
      let data = Object.assign(this.search_data, this.m_page)
      this.m_api.order_comment(data).then(res => {
        console.log(res)
        this.m_list = res.data.data.map(item => {

          item.imgArr = item.images.filter(i => { return i != '' })
          return item
        })
        this.m_page.total = res.data.total
      })
    },



    //审核成功/失败
    m_examine(i) {
      if (!this.m_delId.length) {
        // 请勾选数据
        this.m_warn('请勾选数据')
        return false
      }
      let isSuccess = i == 1
      let data = {
        msg: `确定让${this.m_delId.length}条记录${isSuccess ? '通过审核' : '审核失败'}`
      }
      i
      this.m_confirm(data).then(r => {
        if (r) {
          this.changeStatus(isSuccess)
        }
      })

    },

    //改变状态
    changeStatus(isSuccess) {
      let data = {
        id: this.m_delId,
        status: ""
      };
      if (isSuccess) {
        data.status = 1;
      } else {
        data.status = 2;
      }
      this.set_apply_status(data);
    },

    //审核 申请
    set_apply_status(data) {
      this.m_loading = true
      this.m_api.comment_set_status(data).then(res => {
        this.m_success("操作成功");
        this.m_loading = false

        this.getDatalist();
        this.dialogFormVisible = false
      }).catch(err => {
        this.m_loading = true
      });
    },


    apply_failed(row) {
      this.formData.id = [row.id]
      // this.formData.remark = ''
      // this.dialogFormVisible = true
         this.set_apply_status(this.formData)
    },
    submit() {
      this.$refs['ruleForm'].validate((valid) => {
        if (valid) {
          this.set_apply_status(this.formData)
        } else {
          console.log('error submit!!');
          return false;
        }
      })

    },
    give_reply(row) {
      this.formReply.id = [row.id]
      this.dialogReplyVisible = true
    },
    submitReply() {
      this.set_reply(this.formReply)
    },
    set_reply(data) 
    {
      this.m_loading = true
      this.m_api.comment_set_reply(data).then(res => {
        this.m_success("回复成功");
      }).catch(err => {
        this.m_loading = true
      }).finally(() => {
        this.m_loading = false
        this.getDatalist();
        this.dialogReplyVisible = false
        this.formReply = {
          id: [],
          content: '',
          img: [],
          rawImg: [],
          button: false,
          preview: false,
        }
      });
    },
    handleAvatarSuccess(res, file) {
      this.formReply.img.push(res.data)
      this.formReply.button = true
      this.formReply.preview = true
    },
    handleAvatarRemove(file, fileList) {
      let fileUrl = file.response.data
      for (let index = 0; index < this.formReply.img.length; index++) {
        let spliceList = this.formReply.img[index];
        if (spliceList === fileUrl) 
        {
          this.formReply.img.splice(index,1)             
        }
      }
    },
    handleAvatarExceed(files, fileList) {
        this.m_warning(`最多6张图`);
    },
    beforeAvatarRemove(file, fileList) {
        return this.$confirm(`是否确定删除？`);
    }


  },
  filters: {
    statusClass(v) {

      if (v == 1) { return 'm_green' }
      if (v == 2) { return 'm_red' }

    }
  }
}

</script>
<style lang='scss' scoped>
.imgClass {
  width: 20px;
  height: 20px;
}
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
   width: 174px;
   height: 65px;
  line-height: 65px;
  text-align: center;
  border: 1px dashed #d9d9d9;
}
.avatar {
  width: 174px;
  height: 65px;
  display: block;
  border: 1px dashed #d9d9d9;
}
</style>